(function($){

	$(document).ready( function() {

		var o = {
			pageUrl        		: document.URL,
			pageTitle      		: document.title,
			pageDescription		: $('meta[name="description"]').attr('content'),
			siteTitle					: jpibfi_options.site_title,
			imageSelector			: jpibfi_options.image_selector,
			disabledClasses		: jpibfi_options.disabled_classes,
			enabledClasses		: jpibfi_options.enabled_classes,
			descriptionOption	: jpibfi_options.description_option,
			usePostUrl				: jpibfi_options.use_post_url == "1",
			minImageHeight		: jpibfi_options.min_image_height,
			minImageWidth			: jpibfi_options.min_image_width
		}

		$('.jpibfi').closest('div').addClass('jpibfi_container');

		var notSelector = createSelectorFromList( o.disabledClasses );
		//in case of no enabled classes, we need a selector that takes all elements
		var filterSelector = createSelectorFromList( o.enabledClasses ) || "*";

		$( o.imageSelector )
				.not( notSelector )
				.filter( filterSelector )
				.each( function (i) {	$( this ).attr('data-indexer', i); } );

		function jpibfiAddElements() {

			$("img[data-indexer]").each(function () {
				var $image = $(this);

				if ( this.clientWidth < o.minImageWidth || this.clientHeight < o.minImageHeight ) {
					$image.removeAttr( 'data-indexer' );
					return;
				}

				var indexer = $image.attr("data-indexer"),
						bookmark = 'http://pinterest.com/pin/create/bookmarklet/?is_video=' + encodeURI('false');

				$image.after('<div class="pinit-overlay" data-indexer= "' + indexer + '"><a class="pinit-button" href="' + bookmark + '" data-indexer= "' + indexer + '">Pin It</a></div>');

				var position = $image.offset();

				$('.pinit-overlay[data-indexer="' + indexer + '"]')
							.css({
								height: this.clientHeight + 'px',
								width: this.clientWidth + 'px'
							})
							.show()
							.offset({ left: position.left, top: position.top });
			});

			$('.pinit-button').click( function () {
				var index = $(this).attr("data-indexer");
				var $image = $('img[data-indexer="' + index+ '"]');

				//Bookmark description is created on click because sometimes it's lazy loaded
				var bookmarkDescription = "", descriptionForUrl = "", bookmarkUrl = "";

				//if usePostUrl feature is active, we need to get the data
				if ( o.usePostUrl ) {
					var $inputWithData = $image.closest("div.jpibfi_container").children("input.jpibfi").first();

					if ( $inputWithData.length ) {
						descriptionForUrl = $inputWithData.attr("data-jpibfi-description")
						bookmarkUrl = $inputWithData.attr("data-jpibfi-url");
					}
				}
				bookmarkUrl = bookmarkUrl || o.pageUrl;

				if ( o.descriptionOption == 3 )
					bookmarkDescription = $image.attr('title') || $image.attr('alt');
				else if ( o.descriptionOption == 2 )
					bookmarkDescription = descriptionForUrl || o.pageDescription;
				else if ( o.descriptionOption == 4 )
					bookmarkDescription = o.siteTitle;

				bookmarkDescription = bookmarkDescription || ( descriptionForUrl || o.pageTitle );

				var imageUrl = $(this).attr('href') + "&url=" + encodeURI(bookmarkUrl) + "&media=" + encodeURI ( $image.data('media') || $image[0].src )
						+ '&description=' + encodeURIComponent(bookmarkDescription);

				window.open(imageUrl, 'Pinterest', 'width=632,height=253,status=0,toolbar=0,menubar=0,location=1,scrollbars=1');
				return false;
			});


			$('div.pinit-overlay').hover( function() {
				var indexer = $(this).attr("data-indexer");
				$('.pinit-button[data-indexer="' + indexer + '"]').show();
			}, function() {
				var indexer = $(this).attr("data-indexer");
				$('.pinit-button[data-indexer="' + indexer + '"]').hide();
			});

		}

		function jpibfiRemoveElements() {
			$("div.pinit-overlay").remove();
		}

		$(window).load( jpibfiAddElements );

		$(window).resize ( function() {
			jpibfiRemoveElements();
			jpibfiAddElements();
		});

		//UTILITY FUNCTIONS

		//function creates a selector from a list of semicolon separated classes
		function createSelectorFromList(classes) {
			
			var arrayOfClasses = classes.split(';');

			var selector = "";

			for (var index in arrayOfClasses) {
				if (arrayOfClasses[index])
					selector += '.' + arrayOfClasses[index] + ',';
			}

			if (selector)
				selector = selector.substr(0, selector.length - 1);

			return selector;
		}

	})

})(jQuery);